<?php

namespace App\Http\Requests;

use Illuminate\Validation\Rule;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Request;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Validation\ValidationException;
use Illuminate\Contracts\Validation\Validator;
use Illuminate\Http\Exceptions\HttpResponseException;

/**
 * @property mixed video_type
 * @property mixed video_url
 * @property mixed images
 */
class DetailRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        if (! Auth::check()) {
            return false;
        }
        if(Auth::user()->role == 'admin' )
        {
            return true;
        }

        if(Auth::user()->hasModule('details'))
        {
            return true;
        }
        return Auth::check();
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        $rules=[
            'image' => 'required',
        ];

        foreach (languages() as $language) {
            $langRules = [
                'details_'.$language->local => 'required',
                'details_plus_'.$language->local => 'required',
                'vision_'.$language->local => 'required',
                'mission_'.$language->local => 'required',
                'our_values_'.$language->local => 'required',
                'percentage_text_first_'.$language->local => 'required',
                'percentage_text_second_'.$language->local => 'required',
                'percentage_text_third_'.$language->local => 'required',
                'percentage_first_'.$language->local => 'required',
                'percentage_second_'.$language->local => 'required',
                'percentage_third_'.$language->local => 'required',
            ];

            $rules = array_merge($rules, $langRules);
        }

        return $rules;
    }

    /**
     * Handle a failed validation attempt.
     *
     * Override the parent method action if the request is for AJAX
     *
     * @param Validator $validator
     * @return void
     *
     * @throws ValidationException
     */
    protected function failedValidation(Validator $validator)
    {
        // Change response attitude if the request done via Ajax requests like API requests
        if(Request::wantsJson()){
            $errors = (new ValidationException($validator))->errors();
            throw new HttpResponseException(response()->json(['errors' => $errors], 422));
        } else {
            parent::failedValidation($validator);
        }
    }
}
